unit Main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls;

type
  tmRecord = record
    sec: Integer;     // seconds after the minute - [0,59]
    min: Integer;     // minutes after the hour - [0,59]
    hour: Integer;    // hours since midnight - [0,23]
    mday: Integer;    // day of the month - [1,31]
    mon: Integer;     // months since January - [1,12]
    year: Integer;    // years since 1900
    wday: Integer;    // days since Sunday - [1,7]
    yday: Integer;    // days since January 1 - [1,366]
    isdst: Integer;   // daylight savings time flag
  end;

  ptmRec = ^tmRecord;

  TMainForm = class(TForm)
    edMon: TEdit;
    edDay: TEdit;
    edYear: TEdit;
    edTimet: TEdit;
    edHour: TEdit;
    edMin: TEdit;
    edSec: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    bLocalTime: TBitBtn;
    bGmTime: TBitBtn;
    bMkTime: TBitBtn;
    edDateTime: TEdit;
    Label8: TLabel;
    stBar: TStatusBar;
    edIsdst: TEdit;
    Label9: TLabel;
    edWday: TEdit;
    Label10: TLabel;
    procedure blcltimeClick(Sender: TObject);
    procedure bgmtimeClick(Sender: TObject);
    procedure bmktimeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ShowHint(Sender: TObject);
  end;

  function cgmtime(var tms: tmRecord; var tim: Integer):
    Integer; stdcall; external 'CTime1s.dll';
  function clocaltime(var tms: tmRecord; var tim: Integer):
    Integer; stdcall; external 'CTime1s.dll';
  function cmktime(var tms: tmRecord; var tim: Integer):
    Integer; stdcall; external 'CTime1s.dll';

  function tmToDateTime(var tms: tmRecord): TDateTime;

var
  MainForm: TMainForm;
  tm: tmRecord;
  tt, ret: Integer;

implementation

{$R *.DFM}

procedure TMainForm.FormShow(Sender: TObject);
begin
  Application.OnHint := ShowHint;
  bmktimeClick(Sender);
end;

Procedure TMainForm.ShowHint(Sender: TObject);
begin
  stBar.SimpleText := GetLongHint(Application.Hint);
end;

procedure TMainForm.blcltimeClick(Sender: TObject);
begin
  tt := StrToInt(edTimet.Text);
  ret := clocaltime(tm, tt);

  if (ret > 0) then with tm do begin
    edMon.Text := IntToStr(mon);
    edDay.Text := IntToStr(mday);
    edYear.Text := IntToStr(year);
    edWday.Text := IntToStr(wday) + '/ ' + IntToStr(yday);
    edHour.Text := IntToStr(hour);
    edMin.Text := IntToStr(min);
    edSec.Text := IntToStr(sec);
    edIsDST.Text := IntToStr(isdst);
  end;

  edDateTime.Text := Format('%f', [tmToDateTime(tm)]);
end;

procedure TMainForm.bgmtimeClick(Sender: TObject);
begin
  tt := StrToInt(edTimet.Text);
  ret := cgmtime(tm, tt);

  if (ret > 0) then with tm do begin
    edMon.Text := IntToStr(mon);
    edDay.Text := IntToStr(mday);
    edYear.Text := IntToStr(year);
    edWday.Text := IntToStr(wday) + '/ ' + IntToStr(yday);
    edHour.Text := IntToStr(hour);
    edMin.Text := IntToStr(min);
    edSec.Text := IntToStr(sec);
    edIsDST.Text := IntToStr(isdst);
  end;

  edDateTime.Text := Format('%f', [tmToDateTime(tm)]);
end;

procedure TMainForm.bmktimeClick(Sender: TObject);
begin
  with tm do begin
    mon := StrToInt(edMon.Text);
    mday := StrToInt(edDay.Text);
    year := StrToInt(edYear.Text);
    hour := StrToInt(edHour.Text);
    min := StrToInt(edMin.Text);
    sec := StrToInt(edSec.Text);
    isdst := StrToInt(edIsDST.Text);
  end;

  ret := cmktime(tm, tt);

  if (ret > 0) then edTimet.Text := IntToStr(tt);

  edDateTime.Text := Format('%f', [tmToDateTime(tm)]);
end;

function tmToDateTime(var tms: tmRecord): TDateTime;
begin
  with tms do
    Result := EncodeDate(year, mon, mday) +
    EncodeTime(hour, min, sec, 0);
end;

end.
